/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
#include "SwaggerTradeApiOperations.h"

#include "SwaggerModule.h"
#include "SwaggerHelpers.h"

#include "Dom/JsonObject.h"
#include "Templates/SharedPointer.h"
#include "HttpModule.h"
#include "PlatformHttp.h"

namespace Swagger 
{

FString SwaggerTradeApi::TradeTickerRequest::ComputePath() const
{
	FString Path(TEXT("/ticker"));
	TArray<FString> QueryParams;
	QueryParams.Add(FString(TEXT("markets=")) + ToUrlString(Markets));
	Path += TCHAR('?');
	Path += FString::Join(QueryParams, TEXT("&"));

	return Path;
}

void SwaggerTradeApi::TradeTickerRequest::SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const
{
	static const TArray<FString> Consumes = {  };
	//static const TArray<FString> Produces = { TEXT("application/json") };

	HttpRequest->SetVerb(TEXT("GET"));

	// Default to Json Body request
	if (Consumes.Num() == 0 || Consumes.Contains(TEXT("application/json")))
	{
	}
	else if (Consumes.Contains(TEXT("multipart/form-data")))
	{
	}
	else if (Consumes.Contains(TEXT("application/x-www-form-urlencoded")))
	{
	}
	else
	{
		UE_LOG(LogSwagger, Error, TEXT("Request ContentType not supported (%s)"), *FString::Join(Consumes, TEXT(",")));
	}
}

void SwaggerTradeApi::TradeTickerResponse::SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode)
{
	Response::SetHttpResponseCode(InHttpResponseCode);
	switch ((int)InHttpResponseCode)
	{
	case 200:
	default:
		SetResponseString(TEXT("OK"));
		break;
	case 400:
		SetResponseString(TEXT("Status: Bad Request "));
		break;
	case 401:
		SetResponseString(TEXT("Status: Unauthorized "));
		break;
	case 403:
		SetResponseString(TEXT("Status: Forbidden "));
		break;
	case 404:
		SetResponseString(TEXT("Status: Not Found "));
		break;
	case 500:
		SetResponseString(TEXT("Status: Internal Server Error "));
		break;
	}
}

bool SwaggerTradeApi::TradeTickerResponse::FromJson(const TSharedPtr<FJsonValue>& JsonValue)
{
	return TryGetJsonValue(JsonValue, Content);
}

FString SwaggerTradeApi::TradeTicksRequest::ComputePath() const
{
	FString Path(TEXT("/trades/ticks"));
	TArray<FString> QueryParams;
	QueryParams.Add(FString(TEXT("market=")) + ToUrlString(Market));
	if(To.IsSet())
	{
		QueryParams.Add(FString(TEXT("to=")) + ToUrlString(To.GetValue()));
	}
	if(Count.IsSet())
	{
		QueryParams.Add(FString(TEXT("count=")) + ToUrlString(Count.GetValue()));
	}
	if(Cursor.IsSet())
	{
		QueryParams.Add(FString(TEXT("cursor=")) + ToUrlString(Cursor.GetValue()));
	}
	if(DaysAgo.IsSet())
	{
		QueryParams.Add(FString(TEXT("daysAgo=")) + ToUrlString(DaysAgo.GetValue()));
	}
	Path += TCHAR('?');
	Path += FString::Join(QueryParams, TEXT("&"));

	return Path;
}

void SwaggerTradeApi::TradeTicksRequest::SetupHttpRequest(const TSharedRef<IHttpRequest>& HttpRequest) const
{
	static const TArray<FString> Consumes = {  };
	//static const TArray<FString> Produces = { TEXT("application/json") };

	HttpRequest->SetVerb(TEXT("GET"));

	// Default to Json Body request
	if (Consumes.Num() == 0 || Consumes.Contains(TEXT("application/json")))
	{
	}
	else if (Consumes.Contains(TEXT("multipart/form-data")))
	{
	}
	else if (Consumes.Contains(TEXT("application/x-www-form-urlencoded")))
	{
	}
	else
	{
		UE_LOG(LogSwagger, Error, TEXT("Request ContentType not supported (%s)"), *FString::Join(Consumes, TEXT(",")));
	}
}

void SwaggerTradeApi::TradeTicksResponse::SetHttpResponseCode(EHttpResponseCodes::Type InHttpResponseCode)
{
	Response::SetHttpResponseCode(InHttpResponseCode);
	switch ((int)InHttpResponseCode)
	{
	case 200:
	default:
		SetResponseString(TEXT("OK"));
		break;
	case 400:
		SetResponseString(TEXT("Status: Bad Request "));
		break;
	case 401:
		SetResponseString(TEXT("Status: Unauthorized "));
		break;
	case 403:
		SetResponseString(TEXT("Status: Forbidden "));
		break;
	case 404:
		SetResponseString(TEXT("Status: Not Found "));
		break;
	case 500:
		SetResponseString(TEXT("Status: Internal Server Error "));
		break;
	}
}

bool SwaggerTradeApi::TradeTicksResponse::FromJson(const TSharedPtr<FJsonValue>& JsonValue)
{
	return TryGetJsonValue(JsonValue, Content);
}

}
